-- Ursus 1614
-- by DanstesLS

Ursus_1614 = {};

function Ursus_1614.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Motorized, specializations);
end;

function Ursus_1614:load(xmlFile)
------------------KOGUT--------------------
    self.kogutAnz = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.kogut#count"),0);
    self.kogutKey = getXMLString(xmlFile, "vehicle.kogut#key");
    self.kogutAn = false;
    self.kogut = {};
    for i=1, self.kogutAnz do
        local objname = string.format("vehicle.kogut.light" .. "%d",i);
        self.kogut[i] = {};
        self.kogut[i].rotNode = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, objname .. "#rotNode"));
        self.kogut[i].light = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, objname .. "#light"));
        self.kogut[i].source = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, objname .. "#lightsource"));
        self.kogut[i].speed = Utils.getNoNil(getXMLInt(xmlFile,  objname .. "#rotSpeed"), 1)/1000;
        self.kogut[i].emit = Utils.getNoNil(getXMLBool(xmlFile, objname .. "#emitLight"), true);
        if not self.kogut[i].emit and self.kogut[i].source ~= nil then
           setVisibility(self.kogut[i].source, false);
        end;
    end;
------------------POMOC--------------------------------
    self.controlpath = Utils.getFilename("pomoc.png", self.baseDirectory);
    self.ursusPoxX = 0.01;
    self.ursusPoxY = 1-0.204;
    self.ursusWidth = 0.240;
    self.ursusHeight = 0.240;
    self.ursusPoxX = 0.75;
    self.ursusPoxY = 0.60
    self.ursusOverlay = Overlay:new("ursuscontrol", self.controlpath, self.ursusPoxX, self.ursusPoxY, self.ursusWidth, self.ursusHeight);
----------------------HOLOGENY PRZEDNIE---------------
    self.numhalogenys = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.halogeny_przednie#count"), 0);
    self.halogenys = {};
    for i=1, self.numhalogenys do
        local halogenynamei = string.format("vehicle.halogeny_przednie.halogeny_przednie" .. "%d", i);
        self.halogenys[i] = Utils.indexToObject(self.rootNode, getXMLInt(xmlFile, halogenynamei .. "#index"));
        setVisibility(self.halogenys[i], false);
    end;

  -------------------HALOGENY TYLNE--------------
    self.numtravails = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.halogeny_tylne#count"), 0);
    self.travails = {};
    for i=1, self.numtravails do
        local travailnamei = string.format("vehicle.halogeny_tylne.halogeny_tylne" .. "%d", i);
        self.travails[i] = Utils.indexToObject(self.rootNode, getXMLInt(xmlFile, travailnamei .. "#index"));
        setVisibility(self.travails[i], false);
    end;

  -------------------SWIATLO WEWNATRZ--------------
    self.numpodswietlenies = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.swiatlo_wewnatrz#count"), 0);
    self.podswietlenies = {};
    for i=1, self.numpodswietlenies do
        local podswietlenienamei = string.format("vehicle.swiatlo_wewnatrz.swiatlo_wewnatrz" .. "%d", i);
        self.podswietlenies[i] = Utils.indexToObject(self.rootNode, getXMLInt(xmlFile, podswietlenienamei .. "#index"));
        setVisibility(self.podswietlenies[i], false);
    end;

---------------TYLNA SZYBYA------------------

    local rotationPartNodebackwindow = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.tylna_szyba#index"));
    if rotationPartNodebackwindow ~= nil then
        self.rotationPartbackwindow = {};
        self.rotationPartbackwindow.node = rotationPartNodebackwindow;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationParttylna_szyba#minRot"));
        self.rotationPartbackwindow.minRot = {};
        self.rotationPartbackwindow.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartbackwindow.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartbackwindow.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.tylna_szyba#maxRot"));
        self.rotationPartbackwindow.maxRot = {};
        self.rotationPartbackwindow.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartbackwindow.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartbackwindow.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartbackwindow.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.tylna_szyba#rotTime"), 2)*1000;
        self.rotationPartbackwindow.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.tylna_szyba#touchRotLimit"), 10));
    end;
	
	    local rotationPartNodetloczki = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.tloki#index"));
    if rotationPartNodetloczki ~= nil then
        self.rotationParttloczki = {};
        self.rotationParttloczki.node = rotationPartNodetloczki;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationParttloki#minRot"));
        self.rotationParttloczki.minRot = {};
        self.rotationParttloczki.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationParttloczki.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationParttloczki.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.tloki#maxRot"));
        self.rotationParttloczki.maxRot = {};
        self.rotationParttloczki.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationParttloczki.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationParttloczki.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationParttloczki.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.tloki#rotTime"), 2)*1000;
        self.rotationParttloczki.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.tloki#touchRotLimit"), 10));
    end;



	---------------------------------KIERUNKI-----------------------
	
	   self.numWorklights = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.kierunkowskaz_lewy#count"), 0);
    self.worklights = {};
    for i=1, self.numWorklights do
        local worklightnamei = string.format("vehicle.kierunkowskaz_lewy.kierunkowskaz_lewy" .. "%d", i);
        self.worklights[i] = Utils.indexToObject(self.rootNode, getXMLInt(xmlFile, worklightnamei .. "#index"));
        setVisibility(self.worklights[i], false);
    end;	
	self.worklightsActive = false;
	
    self.numWorklights2 = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.kierunkowskaz_prawy#count"), 0);
    self.worklights2 = {};
    for i=1, self.numWorklights2 do
        local worklightnamei2 = string.format("vehicle.kierunkowskaz_prawy.kierunkowskaz_prawy" .. "%d", i);
        self.worklights2[i] = Utils.indexToObject(self.rootNode, getXMLInt(xmlFile, worklightnamei2 .. "#index"));
        setVisibility(self.worklights2[i], false);
    end;	
	self.worklightsActive2 = false;
	
		turn1SoundFile = Utils.getFilename("turn1.wav", self.baseDirectory);
    self.turn1 = createSample("turn1");
    loadSample(self.turn1, turn1SoundFile, false);
	
	turn2SoundFile = Utils.getFilename("turn2.wav", self.baseDirectory);
    self.turn2 = createSample("turn2");
    loadSample(self.turn2, turn2SoundFile, false);


	----------------------LUSTERKA---------------
    self.numlusterkas = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.lusterka#count"), 0);
    self.lusterkas = {};
    for i=1, self.numlusterkas do
        local lusterkanamei = string.format("vehicle.lusterka.lusterka" .. "%d", i);
        self.lusterkas[i] = Utils.indexToObject(self.rootNode, getXMLInt(xmlFile, lusterkanamei .. "#index"));
        setVisibility(self.lusterkas[i], false);
    end;

	
			

	
	

	
	self.lusterkasActive = false;
	self.podswietleniesActive = false;
	self.travailsActive = false; 
	self.halogenysActive = false;
end;

function Ursus_1614:keyEvent(unicode, sym, modifier, isDown)
--------KOGUT---------------
    if self.isEntered then
      if self.kogutKey ~= nil then
         if isDown and sym == Input[self.kogutKey] then
           self.kogutAn = not self.kogutAn;
           for i=1, self.kogutAnz do
             setVisibility(self.kogut[i].light, self.kogutAn);
           end;
         end;
      end;
    end;

-------------------HALOGENY PRZEDNIE--------------
    if isDown and sym == Input.KEY_4 then
		self.halogenysActive = not self.halogenysActive;
	end;
	
	
  -------------------HALOGENY TYLNE--------------	

	    if isDown and sym == Input.KEY_5 then
		self.travailsActive = not self.travailsActive;
	end;	
	
		  -------------------SWIATLO WEWNATRZ--------------	

	    if isDown and sym == Input.KEY_6 then
		self.podswietleniesActive = not self.podswietleniesActive;
	end;
	
---------------TYLNA SZYBYA------------------
	
	    if isDown and sym == Input.KEY_8 then 
		self.rotationMaxbackwindow = not self.rotationMaxbackwindow;
	end;
		    if isDown and sym == Input.KEY_8 then 
		self.rotationMaxtloczki = not self.rotationMaxtloczki;
	end;
	
---------------------------------KIERUNKI-----------------------	
		if isDown and sym == Input.KEY_KP_6 then
		self.flashLeft = not self.flashLeft;
		self.delayOnLeft = 10;
		self.flashRight = false;
		self.flash = false;
		self.flashlightsRightActive = false;
		self.flashlightsWarnerActive = false;
		self.flashlightsRight2Active = false;
		self.worklightsActive2 = false;
		self.flashWarner = false;
	end;
	
	if isDown and sym == Input.KEY_KP_5 then
		self.flash = not self.flash;
		self.flashRight = false;
		self.flashLeft = false;
		self.delayOn = 20;
		self.flashlightsRightActive = false;
		self.flashlightsLeftActive = false;
		self.flashWarner = not self.flashWarner;
	end;
	
	if isDown and sym == Input.KEY_KP_4 then
		self.flashRight = not self.flashRight;
		self.delayOnRight = 10;
		self.flashLeft = false;
		self.flash = false;
		self.flashlightsLeftActive = false;
		self.flashlightsWarnerActive = false;
		self.flashlightsLeft2Active = false;
		self.worklightsActive = false;
		self.flashWarner = false;
	end;
-------------------LUSTERKA--------------------------	

    if isDown and sym == Input.KEY_9 then
		self.lusterkasActive = not self.lusterkasActive;
	end;
	
	    ----------------POMOC---------------
	    if isDown and sym == 48 then -- Key: 0
		self.pomoc = not self.pomoc;
    end;
	
	
end;


function Ursus_1614:update(dt)
    if self.isEntered then
---------------KOGUT-------------------

  if self.isEntered then
    if self.kogutAnz > 0 then
      if self.kogutAn then
        for i=1, self.kogutAnz do
          rotate(self.kogut[i].rotNode, 0, dt*self.kogut[i].speed, 0);
        end;
      end;
    end;
  end;
  -------------------HALOGENY PRZEDNIE--------------
        if self.halogenysActive then
		   for i=1, self.numhalogenys do
			local halogeny = self.halogenys[i];
			setVisibility(halogeny, self.whalogenysActive);
		   end;
	       else
		   for i=1, self.numhalogenys do
			local halogeny = self.halogenys[i];
			setVisibility(halogeny, self.halogenysActive, false);
		   end;
	    end;
end;
  -------------------HALOGENY TYLNE--------------
        if self.travailsActive then
		   for i=1, self.numtravails do
			local travail = self.travails[i];
			setVisibility(travail, self.travailsActive);
		   end;
	       else
		   for i=1, self.numtravails do
			local travail = self.travails[i];
			setVisibility(travail, self.travailsActive, false);
		   end;
	    end;

	  -------------------SWIATLO WEWNATRZ--------------
        if self.podswietleniesActive then
		   for i=1, self.numpodswietlenies do
			local podswietlenie = self.podswietlenies[i];
			setVisibility(podswietlenie, self.podswietleniesActive);
		   end;
	       else
		   for i=1, self.numpodswietlenies do
			local podswietlenie = self.podswietlenies[i];
			setVisibility(podswietlenie, self.podswietleniesActive, false);
		   end;
	    end
---------------TYLNA SZYBYA------------------
if self.rotationPartbackwindow ~= nil then
		local x, y, z = getRotation(self.rotationPartbackwindow.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartbackwindow.maxRot, self.rotationPartbackwindow.minRot, 3, self.rotationPartbackwindow.rotTime, dt, not self.rotationMaxbackwindow);
		setRotation(self.rotationPartbackwindow.node, unpack(newRot));
   end;	
	
if self.rotationParttloczki ~= nil then
		local x, y, z = getRotation(self.rotationParttloczki.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.rotationParttloczki.maxRot, self.rotationParttloczki.minRot, 3, self.rotationParttloczki.rotTime, dt, not self.rotationMaxtloczki);
		setRotation(self.rotationParttloczki.node, unpack(newRot));
   end;		


---------------------------------KIERUNKI-----------------------

	if self.flash then
		if self.delayOn >= 0 then
			self.delayOn = self.delayOn -dt;
		end;
		if not self.flashlightsRightActive then
			if self.delayOn < 0 then
				self.delayOff = 500;
				self.flashlightsRightActive = true;
				self.flashlightsLeftActive = true;
				self.flashlightsWarnerActive = true;
				self.worklightsActive2 = true;
				self.worklightsActive = true;
				playSample(self.turn1, 1, 0.7, 0);
			end;
		end;
		if self.delayOff >= 0 then
			self.delayOff = self.delayOff -dt;
		end;
		if self.flashlightsRightActive then
			if self.delayOff < 0 then
				self.delayOn = 500;
				self.flashlightsLeftActive = false;
				self.flashlightsRightActive = false;
				self.flashlightsWarnerActive = false;
				self.worklightsActive2 = false;
				self.worklightsActive = false;
				playSample(self.turn2, 1, 0.7, 0);
			end;
		end;
	end;
	
	if self.flashRight then
		if self.delayOnRight >= 0 then
			self.delayOnRight = self.delayOnRight -dt;
		end;
		if not self.flashlightsRightActive then
			if self.delayOnRight < 0 then
				self.delayOffRight = 500;
				self.flashlightsRightActive = true;
				self.worklightsActive2 = true;
				playSample(self.turn1,1,0.7,0);
			end;
		end;
		if self.delayOffRight >= 0 then
			self.delayOffRight = self.delayOffRight -dt;
		end;
		if self.flashlightsRightActive then
			if self.delayOffRight < 0 then
				self.delayOnRight = 500;
				self.flashlightsRightActive = false;
				self.worklightsActive2 = false;
				playSample(self.turn2,1,0.7,0);
			end;
		end;
	else
		if not self.flashWarner then
			self.worklightsActive2 = false;
		end;
	end;
	
	
		if self.flashLeft then
			if self.delayOnLeft >= -1 then
				self.delayOnLeft = self.delayOnLeft -dt;
			end;
			if not self.flashlightsLeftActive then
				if self.delayOnLeft < 0 then
					self.delayOffLeft = 500;
					self.flashlightsLeftActive = true;
					self.worklightsActive = true;
					playSample(self.turn1,1,0.7,0);
				end;
			end;
			if self.delayOffLeft >= 0 then
				self.delayOffLeft = self.delayOffLeft -dt;
			end;
			if self.flashlightsLeftActive then
				if self.delayOffLeft < 0 then
					self.delayOnLeft = 500;
					self.flashlightsLeftActive = false;
					self.worklightsActive = false;
					playSample(self.turn2,1,0.7,0);
				end;
			end;
		else
			if not self.flashWarner then
				self.worklightsActive = false;
			end;
		end;

	

	   if self.worklightsActive then
			for i=1, self.numWorklights do
				local worklight = self.worklights[i];
				setVisibility(worklight, self.worklightsActive);
			end;
		else
			for i=1, self.numWorklights do
				local worklight = self.worklights[i];
				setVisibility(worklight, self.worklightsActive, false);
			end;
		end;

	
	   if self.worklightsActive2 then
			for i=1, self.numWorklights2 do
				local worklight2 = self.worklights2[i];
				setVisibility(worklight2, self.worklightsActive2);
			end;
		else
			for i=1, self.numWorklights2 do
				local worklight2 = self.worklights2[i];
				setVisibility(worklight2, self.worklightsActive2, false);
			end;

		end;

  -------------------LUSTERKA--------------
        if self.lusterkasActive then
		   for i=1, self.numlusterkas do
			local lusterka = self.lusterkas[i];
			setVisibility(lusterka, self.wlusterkasActive);
		   end;
	       else
		   for i=1, self.numlusterkas do
			local lusterka = self.lusterkas[i];
			setVisibility(lusterka, self.lusterkasActive, false);
		   end;
	    end;
end;		
		
		


function Ursus_1614:draw()
if not self.pomoc then
		setTextColor(1,1,1,1);
		renderText(0.80, 0.74, 0.026, "0: Wlacz Pomoc");
	else
		setTextColor(1,1,1,1);
		renderText(0.80, 0.74, 0.026, "0: Wylacz Pomoc");
	end;
	
	if self.pomoc then
	
	
	if self.halogenysActive then
		renderText(0.72, 0.72, 0.021, "4: Wylacz Halogeny przednie");
	else
		renderText(0.72, 0.72, 0.021, "4: Wlacz Halogeny przednie");
	end;
	
	if self.travailsActive then
		renderText(0.72, 0.70, 0.021, "5: Wylacz Halogeny tylne");
	else
		renderText(0.72, 0.70, 0.021, "5: Wlacz Halogeny tylne");
	end;		

	if self.podswietleniesActive then

		renderText(0.72, 0.68, 0.021, "6: Podswietlenie");
	else
		renderText(0.72, 0.68, 0.021, "6: Podswietlenie");
	end;		
	if self.kogutAn then
		renderText(0.72, 0.66, 0.021, "7: Wylacz Kogut");
	else
		renderText(0.72, 0.66, 0.021, "7: Wlacz Kogut");
	end;	
	if self.rotationMaxbackwindow then
		renderText(0.72, 0.64, 0.021, "8: Zamknij Tylna szyba");
	else
		renderText(0.72, 0.64, 0.021, "8: Otworz Tylna szyba");
	end;	
	if self.lusterkasActive then
		renderText(0.72, 0.62, 0.021, "9: Wylacz Lusterka");
	else
		renderText(0.72, 0.62, 0.021, "9: Wlacz Lusterka");
	end;
	if self.flash then
		renderText(0.72, 0.60, 0.021, "NUM 5: Wylacz Awaryjne");
	else
		renderText(0.72, 0.60, 0.021, "NUM 5: Wlacz Awaryjne");
	end;
	if self.flashLeft then
		renderText(0.72, 0.58, 0.021, "NUM 6: Wylacz Prawy kierunek");
	else
		renderText(0.72, 0.58, 0.021, "NUM 6: Wlacz Prawy kierunek");
	end;
	if self.flashRight then
		renderText(0.72, 0.56, 0.021, "NUM 4: Wylacz Lewy kierunek");
	else
		renderText(0.72, 0.56, 0.021, "NUM 4: Wlacz Lewy kierunek");
	end;

end;
end;


function Ursus_1614:onEnter()
    Utils.setEmittingState(self.exhaustParticleLow, false);
end;

function Ursus_1614:onLeave()

self.halogenysActive = false;
	self.kogutAn = false;
    for i=1, self.kogutAnz do
       setVisibility(self.kogut[i].light, self.kogutAn);
    end;

end;

function Ursus_1614:delete()
end;


function Ursus_1614:mouseEvent(posX, posY, isDown, isUp, button)
end;


